"use strict";

{
var ActsObject = 
{
		SpawnAll: function(objectClass, match_size, match_angle, index_num, scale_wid_num, scale_hei_num)
		{
			if( objectClass === undefined || objectClass === null )
			return;

			updateElements(this);

			for( var i=0; i<this.Elements.length; i++ )
			{
				if( __CONSTRUCT2_RUNTIME2__ || __CONSTRUCT3_RUNTIME2__ )
				{	
					var new_inst = this.runtime.createInstance(objectClass, this.layer);
					new_inst.x = this.Elements[i].x;
					new_inst.y = this.Elements[i].y
					
					if( match_size )
					{
						new_inst.width = this.Elements[i].width;
						new_inst.height = this.Elements[i].height;
					}
					
					if( match_angle )
					{
						new_inst.angle = this.Elements[i].angle;
					}

					new_inst.set_bbox_changed();

					
					if( index_num >= 0 )
					{
						if( new_inst.instance_vars[index_num] !== undefined )
						new_inst.instance_vars[index_num] =  this.Elements[i].index;						
					}

					if( scale_wid_num >= 0 )
					{
						if( new_inst.instance_vars[scale_wid_num] !== undefined )
						new_inst.instance_vars[scale_wid_num] =  this.Elements[i].scale_horiz;						
					}

					if( scale_hei_num >= 0 )
					{
						if( new_inst.instance_vars[scale_hei_num] !== undefined )
						new_inst.instance_vars[scale_hei_num] =  this.Elements[i].scale_vert;						
					}
				}

				if( __CONSTRUCT3_RUNTIME3__ )
				{
					var new_inst = this.GetRuntime().CreateInstance(objectClass, this.GetWorldInfo().GetLayer(), this.Elements[i].x, this.Elements[i].y);

					if( match_size )
					{
						new_inst.GetWorldInfo().SetWidth(this.Elements[i].width);
						new_inst.GetWorldInfo().SetHeight(this.Elements[i].height);						
					}

					if( match_angle )
					{
						new_inst.GetWorldInfo().SetAngle(this.Elements[i].angle);
					}

					new_inst.GetWorldInfo().SetBboxChanged();


					if( index_num >= 0 )
					{
						//if( new_inst.GetInstanceVariableCount() >= 1 )
						new_inst.SetInstanceVariableValue(index_num, this.Elements[i].index);
					}

					if( scale_wid_num >= 0 )
					{
						//if( new_inst.GetInstanceVariableCount() >= 1 )
						new_inst.SetInstanceVariableValue(scale_wid_num, this.Elements[i].scale_horiz);
					}

					if( scale_hei_num >= 0 )
					{
						//if( new_inst.GetInstanceVariableCount() >= 1 )
						new_inst.SetInstanceVariableValue(scale_hei_num, this.Elements[i].scale_vert);
					}

				}
			}

		},
		SpawnOne: function(objectClass, index, match_size, match_angle, index_num, scale_wid_num, scale_hei_num)
		{
			if( objectClass === undefined || objectClass === null )
			return;

			updateElements(this)

			var i = index;
			//for( var i=0; i<this.Elements.length; i++ )
			{
				if( __CONSTRUCT2_RUNTIME2__ || __CONSTRUCT3_RUNTIME2__ )
				{	
					var new_inst = this.runtime.createInstance(objectClass, this.layer);
					new_inst.x = this.Elements[i].x;
					new_inst.y = this.Elements[i].y
					
					if( match_size )
					{
						new_inst.width = this.Elements[i].width;
						new_inst.height = this.Elements[i].height;
					}
					
					if( match_angle )
					{
						new_inst.angle = this.Elements[i].angle;
					}

					new_inst.set_bbox_changed();

					
					if( index_num >= 0 )
					{
						if( new_inst.instance_vars[index_num] !== undefined )
						new_inst.instance_vars[index_num] =  this.Elements[i].index;						
					}

					if( scale_wid_num >= 0 )
					{
						if( new_inst.instance_vars[scale_wid_num] !== undefined )
						new_inst.instance_vars[scale_wid_num] =  this.Elements[i].scale_horiz;						
					}

					if( scale_hei_num >= 0 )
					{
						if( new_inst.instance_vars[scale_hei_num] !== undefined )
						new_inst.instance_vars[scale_hei_num] =  this.Elements[i].scale_vert;						
					}
				}

				if( __CONSTRUCT3_RUNTIME3__ )
				{
					var new_inst = this.GetRuntime().CreateInstance(objectClass, this.GetWorldInfo().GetLayer(), this.Elements[i].x, this.Elements[i].y);

					if( match_size )
					{
						new_inst.GetWorldInfo().SetWidth(this.Elements[i].width);
						new_inst.GetWorldInfo().SetHeight(this.Elements[i].height);						
					}

					if( match_angle )
					{
						new_inst.GetWorldInfo().SetAngle(this.Elements[i].angle);
					}

					new_inst.GetWorldInfo().SetBboxChanged();


					if( index_num >= 0 )
					{
						//if( new_inst.GetInstanceVariableCount() >= 1 )
						new_inst.SetInstanceVariableValue(index_num, this.Elements[i].index);
					}

					if( scale_wid_num >= 0 )
					{
						//if( new_inst.GetInstanceVariableCount() >= 1 )
						new_inst.SetInstanceVariableValue(scale_wid_num, this.Elements[i].scale_horiz);
					}

					if( scale_hei_num >= 0 )
					{
						//if( new_inst.GetInstanceVariableCount() >= 1 )
						new_inst.SetInstanceVariableValue(scale_hei_num, this.Elements[i].scale_vert);
					}

				}
			}

		},
		setCellsNumber: function(num)
		{
			this.el_count = num;

			updateElements(this);
		},
		setCellWidth: function(num)
		{
			this.el_width = num;

			updateElements(this);
		},
		setCellHeight: function(num)
		{
			this.el_height = num;

			updateElements(this);
		},
		setWidthSpacing: function(num)
		{
			this.space_width = num;

			updateElements(this);
		},
		setHeightSpacing: function(num)
		{
			this.space_height = num;

			updateElements(this);
		},
		setColumnsMode: function(num)
		{
			this.threads_mode = num;

			updateElements(this);
		},
		setThreadsNumber: function(num)
		{
			this.threads = num;

			updateElements(this);
		},
		setFillWidthMode: function(num)
		{
			this.fill_mode_width = num;

			updateElements(this);
		},
		setFillHeightMode: function(num)
		{
			this.fill_mode_height = num;

			updateElements(this);
		},
		setKeepRatio: function(num)
		{
			this.keep_ratio = num;

			updateElements(this);
		},
		setHorizontalFloat: function(num)
		{
			this.float_horiz = num;

			updateElements(this);
		},
		setVerticalFloat: function(num)
		{
			this.float_vert = num;

			updateElements(this);
		},
		setFlow: function(num)
		{
			this.flow = num;

			updateElements(this);
		},
		setMainAxisDirection: function(num)
		{
			this.main_axis_dir = num;

			updateElements(this);
		},
		setCrossAxisDirection: function(num)
		{
			this.cross_axis_dir = num;

			updateElements(this);
		}
};

	C3.Plugins.ValerypopoffLayouterPlugin.Acts = {};

	for( var k in ActsObject )
	{
		C3.Plugins.ValerypopoffLayouterPlugin.Acts[k] = ActsObject[k];
	}
}

C3.Plugins.ValerypopoffLayouterPlugin.Instance.prototype.ACTS = C3.Plugins.ValerypopoffLayouterPlugin.Acts;
